<script setup lang="ts">
import { useTemplateRef, computed } from 'vue';
import { type Person } from '../types/Person';
import CheckMark from './CheckMark.vue';
import { RouterLink } from 'vue-router';

const props = withDefaults(
  defineProps<{
    person?: Person;
    width?: number;
    hasCheckmark?: boolean;
    degrees?: number;
    preventClick?: boolean;
  }>(),
  { degrees: 33, width: 256 }
);

const checkmark = useTemplateRef('checkmark');

const imageSize = computed(() => `${props.width}px`);

const radians = computed(() => props.degrees / (180 / Math.PI));

const checkmarkWidth = computed(() => {
  if (!props.hasCheckmark || !checkmark?.value) {
    return 0;
  }
  return (checkmark.value as any).$el.getBoundingClientRect().width;
});

const checkmarkLeft = computed(() => {
  if (checkmarkWidth.value === 0) {
    return `-10000px`;
  }
  return `${(props.width / 2) * Math.cos(radians.value) + props.width / 2 - checkmarkWidth.value / 2}px`;
});

const checkmarkTop = computed(() => {
  if (checkmarkWidth.value === 0) {
    return `-10000px`;
  }
  return `${(props.width / 2) * Math.sin(radians.value) + props.width / 2 - checkmarkWidth.value / 2}px`;
});

const pictureUrl = computed(() => (props.person ? props.person.image || '' : ''));
</script>

<template>
  <div :style="{ width: imageSize, height: imageSize, position: 'relative' }">
    <CheckMark v-if="hasCheckmark" ref="checkmark" :style="{ position: 'absolute', top: checkmarkTop, left: checkmarkLeft, 'z-index': 1 }" />
    <div v-if="preventClick">
      <div v-if="pictureUrl === ''" class="w-full h-full bg-sdg-background-light-grey flex justify-center items-center image">No image</div>
      <img v-else :src="pictureUrl" class="w-full h-full bg-white-900 image" />
    </div>
    <router-link v-else :to="{ name: 'aboutperson', query: { id: props.person?.id } }">
      <div v-if="pictureUrl === ''" class="w-full h-full bg-sdg-background-light-grey flex justify-center items-center image">No image</div>
      <img v-else :src="pictureUrl" class="w-full h-full bg-white-900 image" />
    </router-link>
  </div>
</template>
<style scoped>
.image {
  border: 4px rgba(0, 0, 0, 0.2);
  border-radius: 50%;
  padding: 2px;
}
</style>
